"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
describe('Type', () => {
    it('basic Type with toMatchType', () => {
        class C {
            m() {
                return false;
            }
        }
        expect({
            m() {
                return 12;
            }
        }).toMatchType(__1.Type());
        expect({
            m() {
                return '12';
            }
        }).not.toMatchType(__1.Type());
        expect({
            m() {
                return false;
            }
        }).toMatchType(__1.Type());
        expect({
            m() {
                return new Date();
            }
        }).not.toMatchType(__1.Type());
    });
    it('should be able to reference types declared on any scope', () => {
        expect('a').not.toMatchType(__1.Type());
        expect(2).not.toMatchType(__1.Type());
        expect(1).toMatchType(__1.Type(), {});
        var b = { a: 1, b: 's' };
        expect(true).not.toMatchType(__1.Type());
        expect(true).toMatchType(__1.Type());
    });
    it('should be able to pass a type as value for complex asserts', () => {
        expect(__1.Type()).toMatchType(v => `
      var var_a: ${v} = null as any as ${v}
      var var_b = var_a[33] 
      `, { asString: true });
        expect(__1.Type()).toMatchType(v => `
      var var_a: ${v} = null as any as ${v}
      var var_b = var_a[1]  
      `, { asString: true });
        expect(__1.Type()).not.toMatchType(v => `
      var var_a: ${v} = null as any as ${v}
      var var_b = var_a[33] 
      `, { asString: true });
        expect(__1.Type()).toMatchType(v => `
      var var_a: ${v} = null as any as ${v}
      var var_b = var_a[1] 
      `, { asString: true });
    });
    it('should be able to pass undefined as value', () => {
        expect(undefined).not.toMatchType(__1.Type());
    });
});
