"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const compile_1 = require("../compile");
describe('compile', () => {
    describe('checkCompile', () => {
        class C {
            m() {
                return false;
            }
        }
        it('should reference given list of types', () => {
            let r;
            r = compile_1.checkCompile({}, (I, returnType) => `
    var c: {m():${returnType}} = null as any
    var d: ${I} = c    
    `, __1.Type(), __1.Type());
            expect(r.pass).toBe(false);
            expect(r.failErrors).toHaveLength(1);
            expect(r.failErrors[0].code).toBe(2322);
            expect(r.failErrors[0].message).toContain('is not assignable');
            r = compile_1.checkCompile({}, (I, returnType) => `
    var c: {m():${returnType}} = null as any
    var d: ${I} = c
    `, __1.Type(), __1.Type());
            expect(r.pass).toBe(true);
            expect(r.failErrors).toHaveLength(0);
        });
    });
    describe('expectCompile', () => {
        it('should let me test code arbitrarily', () => {
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Array2} = [{n: 1}, {n: 2}]`, __1.Type(), __1.Type())).toBe(true);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Tuple2} = [{n: 1}, {n: 2}]`, __1.Type(), __1.Type())).toBe(true);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Array2} = [{n: 1}, {n: '2'}]`, __1.Type(), __1.Type())).toBe(false);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Tuple2} = [{n: 1}, {n: '2'}]`, __1.Type(), __1.Type())).toBe(false);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Array2} = [{n: 1}, {n: 2}, {n: 3}]`, __1.Type(), __1.Type())).toBe(false);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Tuple2} = [{n: 1}, {n: 2}, {n: 3}]`, __1.Type(), __1.Type())).toBe(false);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Array2} = [{n: 1}, {n: 2}]; var d = c[3]`, __1.Type(), __1.Type())).toBe(false);
            expect(compile_1.expectCompile({}, (Array2, Tuple2) => `var c: ${Tuple2} = [{n: 1}, {n: 2} ]; var d = c[3]`, __1.Type(), __1.Type())).toBe(true);
        });
    });
});
