"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const expectType_1 = require("../expectType");
test('types imported from other files or projects is fine', () => {
    expect(expectType_1.expectType('KeysToTuple<typeof Object.prototype>', 'will fail')).toBe(false);
    expect(expectType_1.expectType('KeysToTuple<typeof Object.prototype>', ['hasOwnProperty', 'isPrototypeOf', 'propertyIsEnumerable'], {
    // printResultIfFail: true,
    })).toBe(true);
});
test('types declared in the global scope of this file (cannot be declared in a closure)', () => {
    expect(expectType_1.expectType('UnionOf<[1,2]>', 'will fail')).toBe(false);
    expect(expectType_1.expectType('UnionOf<[1,2]>', 1)).toBe(true);
    expect(expectType_1.expectType('UnionOf<[1,2]>[]', [2, 1])).toBe(true);
    expect(expectType_1.expectType('UnionOf<[1,2]>[]', [1, 2, 3])).toBe(false);
});
test('should use functions and value is escaped automatically', () => {
    expect(expectType_1.expectType(value => `
      type F = (...args: any[])=>number
      var a: F = ${value}`, () => 'fails')).toBe(false);
    expect(expectType_1.expectType(value => `
      type F = (...args: any[])=>number
      var a: F = ${value}`, () => Math.E)).toBe(true);
});
test('types lost wont impact if types can be inferred, but it will cause false positives', () => {
    expect(expectType_1.expectType(value => `const v: typeof Math.pow = ${value}`, (a, b) => 1)).toBe(true);
    expect(expectType_1.expectType(value => `const v: typeof Math.pow = ${value}`, (a, b) => 1)).toBe(true); // this should not match, but because types are lost it does
});
