"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const checkType_1 = require("./checkType");
function checkCompile(options = {}, value, ...types) {
    const code = buildCode(types, value);
    const result = checkType_1.checkTypeCore(code, '', Object.assign({}, options, { asString: true, dontCreateTestCodeVariable: true }));
    return result;
}
exports.checkCompile = checkCompile;
function expectCompile(options = {}, value, ...types) {
    const code = buildCode(types, value);
    const result = checkType_1.checkTypeCore(code, '', Object.assign({}, options, { asString: true, dontCreateTestCodeVariable: true }));
    return result.pass;
}
exports.expectCompile = expectCompile;
function buildCode(types, value) {
    const prefix = types
        .map(t => t.__tsdCR_prefix)
        .filter((t, i, a) => a.indexOf(t) === i)
        .join('\n');
    const typeStrings = types.map(t => t.text); //as CTuple<string, L>;
    const valueString = value(...typeStrings);
    const code = `
  // PREFIX
  ${prefix}
  // TYPE
  ${valueString}`;
    return code;
}
