"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const checkType_1 = require("./checkType");
const util_1 = require("./util");
const compile_1 = require("./compile");
if (typeof expect !== 'undefined') {
    expect.extend({
        toMatchType(value, type, options = {}) {
            if (options.exactly) {
                type = `
function ${util_1.unique('__jestMatcher_toMatchType')}(){
  type ExactlyMatch<t1, t2> = t1 extends t2 ? t2 extends t1 ? true : never : never
  var anotherVariable = ${util_1.escapeValue(value, options)}
  var variableToMatchTypeExactly: ExactlyMatch<${type}, typeof anotherVariable> = true
}`;
                options = Object.assign({}, options, { dontCreateTestCodeVariable: true });
            }
            const r = checkType_1.checkType(type, value, options);
            return {
                pass: r.pass,
                message: () => `expect value ${util_1.escapeValue(value, options)} ${this.isNot ? 'not ' : ''}to match ${typeof type === 'string' ? `type ${type}` : `types in code "${r.testCode}"`} but ${this.isNot
                    ? 'did'
                    : `[${r.failErrors
                        ? r.failErrors.map(r => `(${r.code}) ${r.message}`).join('\n')
                        : r.error
                            ? r.error
                            : 'UNKNOWN'}]`}`
            };
        },
        toCompile(value, ...optionsOrTypes) {
            let { options, types } = optionsOrTypes.length
                ? typeof optionsOrTypes[0].__tsdCR_prefix === 'string'
                    ? { options: {}, types: optionsOrTypes }
                    : {
                        options: optionsOrTypes[0],
                        types: optionsOrTypes.slice(1, optionsOrTypes.length)
                    }
                : { options: {}, types: [] };
            const r = compile_1.checkCompile(options, value, ...types);
            return {
                pass: r.pass,
                message: () => `expect value "${value}" ${this.isNot ? 'not ' : ''}to compile but ${this.isNot
                    ? 'did'
                    : `thrown [${r.failErrors
                        ? r.failErrors.map(r => `(${r.code}) ${r.message}`).join('\n')
                        : r.error
                            ? r.error
                            : 'UNKNOWN'}]`}`
            };
        }
    });
}
