import { Diagnostic } from 'ts-simple-ast';
import { Options, CompilationError } from './types';
/** @internal */
export declare function formatDiagnostics(d: Diagnostic[]): CompilationError[];
/** @internal */
export declare function unique(prefix?: string): string;
/** @internal */
export declare function quote(s: string, q?: string): string;
/** @internal */
export declare function escapeValue<T>(v: T, options: Options): string | undefined;
/** @internal */
export declare function getCallerFile(): {
    callerFile: string | undefined;
    allCallerFiles: string[];
};
export declare type ArrayLiteral<T, L> = 0 extends L ? [] : 1 extends L ? [T] : 2 extends L ? [T, T] : 3 extends L ? [T, T, T] : 4 extends L ? [T, T, T, T] : 5 extends L ? [T, T, T, T, T] : 6 extends L ? [T, T, T, T, T, T] : 7 extends L ? [T, T, T, T, T, T, T] : 8 extends L ? [T, T, T, T, T, T, T, T] : 9 extends L ? [T, T, T, T, T, T, T, T, T] : 10 extends L ? [T, T, T, T, T, T, T, T, T, T] : 11 extends L ? [T, T, T, T, T, T, T, T, T, T, T] : never;
export declare type Tuple<TItem, TLength extends number> = [TItem, ...TItem[]] & {
    length: TLength;
};
